import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class MandagsChancenFrame extends JApplet implements MouseListener, ActionListener  {

  static final int SOEJLER  = 3;
  static final int RAEKKER = 3;
  static final int BLUE=2;
  static final int WHITE=1;

  static String[] beloeb ={"10.000","10.000","25.000","25.000","50.000","50.000","100.000",
                           "100.000","250.000"};
  static String[] feltNoStr={"1","2","3","4","5","6","7","8","9"};
  static boolean[] optaget={false,false,false,false,false,false,false,false,false};
  static String[] felt = new String[9];
  String feltBeloeb="00.000";
  static float gevinstFelt=0,sidsteFelt=0;
  static int antalForsoeg=0;
  static boolean stop=false, fortsaet=false;
  static int fontSize = 24;
  static int width,height;
  static int brikWidth, brikHeight;

  Graphics graphics;

  JFrame frame = new JFrame("MandagsChancen");
  Container pane = frame.getContentPane();

  JLabel dialogLabel= new JLabel("Tryk p start. Klik herefter p et felt. Mske er du heldig!");
  JButton startButton = new JButton("Start");
  JButton fortsaetButton = new JButton("Fortst");
  JButton stopButton = new JButton("Stop");

  public void init() {
    int plads;
    for(int i=0; i<=8; i++) {
      plads=(int)(9*Math.random());
      while (optaget[plads]) {
        plads=(int)(9*Math.random());
      }
      optaget[plads]=true;
      felt[i]=beloeb[plads];
    }

    width=getBounds().width;
    height=getBounds().height;
    brikWidth= width /SOEJLER;
    brikHeight = height/RAEKKER;
    pane.setLayout(new GridLayout(4,1));

    pane.add(dialogLabel);
    pane.add(startButton);
    pane.add(fortsaetButton);
    pane.add(stopButton);
    startButton.addActionListener(this);
    fortsaetButton.addActionListener(this);
    stopButton.addActionListener(this);
    getContentPane().addMouseListener(this);
    frame.pack();
    frame.show();
  }

  public void paint(Graphics graphics) {
    this.graphics = graphics;
    graphics.setFont(new Font("Serif", Font.BOLD, fontSize));
    graphics.setColor(Color.blue);
    tegnBrikker();
  }

  private void tegnBrikker() {
    for (int raekke=1; raekke <= RAEKKER; raekke++) {
      for (int soejle=1; soejle <= SOEJLER; soejle++) {
        tegnBrik(raekke,soejle,BLUE);
      }
    }
  }

  private void tegnBrik(int raekke, int soejle, int color) {
    graphics=this.getGraphics();
    if (color==BLUE)
      graphics.setColor(Color.blue);
    else
      graphics.setColor(Color.white);

    int x1 = (soejle-1)*brikWidth;
    int y1 = (raekke-1)*brikHeight;

    graphics.fillRect(x1,y1,brikWidth-1,brikHeight-1);
    graphics.setColor(Color.gray);
    graphics.drawRect(x1,y1,brikWidth-1,brikHeight-1);
    graphics.setColor(Color.white);
    graphics.drawRect(x1+1,y1+1,brikWidth-3,brikHeight-3);
    graphics.setColor(Color.gray);
    graphics.drawRect(x1+2,y1+2,brikWidth-5,brikHeight-5);
    fontSize=2*brikHeight/3;
    graphics.setFont(new Font("Serif", Font.BOLD, fontSize));
    graphics.setColor(Color.white);
    int feltNo=(raekke-1)*SOEJLER+soejle;
    graphics.drawString(feltNoStr[feltNo-1],x1+40,y1+4*brikHeight/5);
  }

  private int pixelTilSoejle(int x) {
    float floatx=(float)x;
    float floatbrikWidth=(float)brikWidth;
    return (int)(floatx/floatbrikWidth)+1;
  }

  private int pixelTilRaekke(int y) {
    float floaty=(float)y;
    float floatbrikHeight=(float)brikHeight;
    return (int)(floaty/floatbrikHeight)+1;
  }

  public void mouseClicked(MouseEvent mouseEvent) {
    int raekke=pixelTilRaekke(mouseEvent.getY());
    int soejle=pixelTilSoejle(mouseEvent.getX());
     if (stop)
      dialogLabel.setText("Du kan ikke afdkke flere felter, nr du har stoppet");
    else
    if (fortsaet) {
      if ((raekke>0) && (soejle>0) && (raekke<=RAEKKER) && (soejle<=SOEJLER)) {
        int feltNo=(raekke-1)*SOEJLER+soejle;
        if (optaget[feltNo-1]) {
          optaget[feltNo-1]=false;
          fortsaet=false;
          antalForsoeg++;
          sidsteFelt=gevinstFelt;
          feltBeloeb=felt[feltNo-1];
          gevinstFelt=Float.parseFloat(felt[feltNo-1]);
          graphics=this.getGraphics();
          tegnBrik(raekke,soejle,WHITE);
          graphics.setColor(Color.red);
          fontSize = brikHeight/4;
          graphics.setFont(new Font("Serif", Font.BOLD, fontSize));
          int x1=(soejle-1)*brikWidth;
          int y1=(raekke-1)*brikHeight;
          graphics.drawString(felt[feltNo-1],x1+10,y1+5*fontSize/2);
          if (gevinstFelt<sidsteFelt) {
            dialogLabel.setText("Spillet er afsluttet! Du satsede forkert og har mistet alt");
            feltBeloeb="0";
            stop=true;
          }
          else {
            if (antalForsoeg==3) {
              dialogLabel.setText("Spillet er afsluttet! Du vandt "+felt[feltNo-1]+" kr.");
              stop=true;
            }
            else {
              int antalForsoegTilbage=3-antalForsoeg;
              dialogLabel.setText("Du har "+antalForsoegTilbage+
                                  " chancer tilbage. Tryk Fortst for at fortstte");
            }
          }
        }
        else dialogLabel.setText("Du kan ikke afdkke samme felt to gange!");
      }
    }
    else
      dialogLabel.setText("Tryk Fortst-knappen, fr du klikker p et felt!");
  }

  public void mouseEntered(MouseEvent mouseEvent) {
  }

  public void mouseExited(MouseEvent mouseEvent) {
  }

  public void mousePressed(MouseEvent mouseEvent) {
  }

  public void mouseReleased(MouseEvent mouseEvent) {
  }

  public void actionPerformed(ActionEvent actionEvent) {
    if (actionEvent.getActionCommand().equals("Start")) {
      if (antalForsoeg==0) {
        fortsaet=true;
        dialogLabel.setText("Klik p et felt. Mske er du heldig!");
      }
      else {
        dialogLabel.setText("Du kan ikke begynde forfra!!");
        stop=true;
      }
    }
    else
    if (actionEvent.getActionCommand().equals("Fortst")) {
      if (antalForsoeg==3) {
          dialogLabel.setText("Spillet er afsluttet! Du har kun 3 forsg");
          stop=true;
      }
      else
        if(stop)
          dialogLabel.setText("Du kan ikke afdkke flere felter, nr du har stoppet");
        else {
          fortsaet=true;
          dialogLabel.setText("Klik p et nyt felt. Mske er du heldig");
        }
    }
    else
      if (actionEvent.getActionCommand().equals("Stop")) {
        dialogLabel.setText("Spillet er afsluttet! Du vandt "+feltBeloeb+" kr.");
        stop=true;
      }
  }
}
