package rtl;

import java.io.*;

public class KbdRead {
  BufferedReader Kbd=new BufferedReader(new InputStreamReader(System.in));

  public String readString() {
    String str="";
    try {
      str = Kbd.readLine();
    }
    catch (IOException e) {
      System.out.println("IOexception :"+e);
    }
    return str;
  }

  public char readChar() {
    char key='\r', retur, lineFeed;
    try {
      key=(char) System.in.read();
      if (key!='\r') retur=(char) System.in.read();
      lineFeed=(char) System.in.read();
    }
    catch (IOException e) {
      System.out.println("IOexception :"+e);
    }
    return key;
  }

  public int readInteger() {
    String str="";
    try {
      str = Kbd.readLine();
    }
    catch (IOException e) {
      System.out.println("IOexception :"+e);
    }
    return Integer.parseInt(str);
  }

  boolean eol(char tegn) {
    return (tegn=='\r');
  }

  boolean ciffer(char tegn) {
    return ((tegn>='0') && (tegn<='9'));
  }

  int value(char ciffer) {
    char cifre[]={'0','1','2','3','4','5','6','7','8','9'};
    int i=0;
    while (ciffer!=cifre[i]) i++;
    return i;
  }

  public float readFloat() {
    String str="";
    try {
      str = Kbd.readLine();
    }
    catch (IOException e) {
      System.out.println("IOexception :"+e);
    }
    return Float.parseFloat(str);
  }

  public double readDouble() {
    String str="";
    try {
      str = Kbd.readLine();
    }
    catch (IOException e) {
      System.out.println("IOexception :"+e);
    }
    return Double.parseDouble(str);
  }


  public float readReal() {
    char tegn;
    boolean negative=false;
    float tal=0;
    float p10=10;
    try {
      tegn=(char) System.in.read();
      if ((tegn=='-') || (tegn=='+')) {
        if (tegn=='-') negative=true;
        tegn=(char) System.in.read();
      }
      if ( ciffer(tegn)) {
        do {
          tal=tal*10+(float) value(tegn);
          tegn=(char) System.in.read();
        }
        while (ciffer(tegn));
      }
      if ((tegn=='.') || (tegn==',') ) {
        tegn=(char) System.in.read();
        while (ciffer(tegn)) {
          tal=tal+(float) value(tegn)/p10;
          p10=p10*10;
          tegn=(char) System.in.read();
        }
      }
      tegn=(char) System.in.read();
    }
    catch (IOException e) {
      System.out.println("IOexception :"+e);
    }
    if (negative) tal=-tal;
    return tal;
  }
}
